#include <iostream>
using namespace std;

typedef long long ll;

const int N = 1000001;
ll ft[N];

void update(ll n)
{
	for (; n < N; n += n & -n)
		ft[n] += 1;
}
ll query(int n)
{
	ll ret = 0;
	for (; n > 0; n -= n & -n)
		ret += ft[n];
	return ret;
}

int main()
{
	int t;
	cin >> t;
	for (ll i = 1; i < 1000000; ++i)
		for (ll j = i + 1; j < 1000000 && i * j < 1000000; ++j)
			for (ll k = j + 1; k < 1000000 && i * k * j <= 1000000; ++k)
				update(i * k * j);
				
	while (t--)
	{
		ll n;
		cin >> n;
		cout << query(n) << '\n';
	}
}
